(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@angular/material/tabs'), require('@angular/material/grid-list'), require('@angular/material/card'), require('@angular/material/button'), require('@angular/material/input'), require('@angular/material/form-field'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('reports-hyper74', ['exports', '@angular/core', '@angular/common/http', '@angular/material/tabs', '@angular/material/grid-list', '@angular/material/card', '@angular/material/button', '@angular/material/input', '@angular/material/form-field', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["reports-hyper74"] = {}, global.ng.core, global.ng.common.http, global.ng.material.tabs, global.ng.material.gridList, global.ng.material.card, global.ng.material.button, global.ng.material.input, global.ng.material.formField, global.ng.router));
})(this, (function (exports, i0, i1, i2, i3, i4, i5, input, formField, router) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i5__namespace = /*#__PURE__*/_interopNamespace(i5);

    var ReportsService = /** @class */ (function () {
        function ReportsService(httpClient) {
            this.httpClient = httpClient;
        }
        ReportsService.prototype.loadGroups = function () {
            return this.httpClient.get("/rpt/groups");
        };
        ReportsService.prototype.listReportsByGroupId = function (groupId) {
            return this.httpClient.get("/rpt/report/group/" + groupId);
        };
        ReportsService.prototype.getReportWithFilters = function (reportId) {
            return this.httpClient.get("/rpt/report/" + reportId);
        };
        return ReportsService;
    }());
    ReportsService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsService, deps: [{ token: i1__namespace.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    ReportsService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.HttpClient }]; } });

    var ReportsComponent = /** @class */ (function () {
        function ReportsComponent(reportService) {
            this.reportService = reportService;
            this.reportsGroups = [];
            this.reportsByGroupId = [];
            this.$subs = [];
            this.onViewClicked = new i0.EventEmitter();
            this.breakpoint = 2;
            this.selectedIndex = 0;
        }
        ReportsComponent.prototype.ngOnInit = function () {
            this.loadGroups();
        };
        ReportsComponent.prototype.loadGroups = function () {
            var _this = this;
            var sub1 = this.reportService.loadGroups().subscribe(function (res) {
                _this.reportsGroups = res;
                _this.$subs.push(sub1);
            });
        };
        ReportsComponent.prototype.listReportsByGroupId = function (groupId) {
            var _this = this;
            var sub2 = this.reportService.listReportsByGroupId(groupId).subscribe(function (res2) {
                _this.reportsByGroupId = res2;
            });
            this.$subs.push(sub2);
        };
        ;
        ReportsComponent.prototype.onTabChanged = function (event) {
            this.listReportsByGroupId(this.reportsGroups[event].id);
        };
        ReportsComponent.prototype.viewReportFilterDetails = function (report) {
            this.onViewClicked.emit(report);
        };
        ReportsComponent.prototype.ngOnDestroy = function () {
            this.$subs.forEach(function (item) { return item.unsubscribe(); });
        };
        return ReportsComponent;
    }());
    ReportsComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsComponent, deps: [{ token: ReportsService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ReportsComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: ReportsComponent, selector: "lib-reports-groups", outputs: { onViewClicked: "onViewClicked" }, ngImport: i0__namespace, template: "\n\n    <mat-tab-group *ngIf=\"reportsGroups\" (selectedIndexChange)=\"onTabChanged($event)\">\n      <mat-tab  [id]=\"group.id\" *ngFor=\"let group of reportsGroups;let i=index\" label=\"{{group.name}}\" >\n        <mat-grid-list class=\"mt-2\" [cols]=\"breakpoint\"  rowHeight=\"200px\">\n          <mat-grid-tile *ngFor=\"let report of reportsByGroupId\">\n            <mat-card class=\"example-card\" >\n              <mat-card-title>{{report.name}}</mat-card-title>\n              <mat-card-content>\n                <p>{{report.descreption}}</p>\n              </mat-card-content>\n              <mat-card-actions>\n                <button mat-button class=\"viewButton\" (click)=\"viewReportFilterDetails(report)\">View</button>\n              </mat-card-actions>\n            </mat-card>\n          </mat-grid-tile>\n        </mat-grid-list>\n\n      </mat-tab>\n    </mat-tab-group>\n\n\n\n  ", isInline: true, components: [{ type: i2__namespace.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "disableRipple"], exportAs: ["matTabGroup"] }, { type: i2__namespace.MatTab, selector: "mat-tab", inputs: ["disabled", "label", "aria-label", "aria-labelledby"], exportAs: ["matTab"] }, { type: i3__namespace.MatGridList, selector: "mat-grid-list", inputs: ["cols", "gutterSize", "rowHeight"], exportAs: ["matGridList"] }, { type: i3__namespace.MatGridTile, selector: "mat-grid-tile", inputs: ["rowspan", "colspan"], exportAs: ["matGridTile"] }, { type: i4__namespace.MatCard, selector: "mat-card", exportAs: ["matCard"] }, { type: i5__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i4__namespace.MatCardTitle, selector: "mat-card-title, [mat-card-title], [matCardTitle]" }, { type: i4__namespace.MatCardContent, selector: "mat-card-content, [mat-card-content], [matCardContent]" }, { type: i4__namespace.MatCardActions, selector: "mat-card-actions", inputs: ["align"], exportAs: ["matCardActions"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-reports-groups',
                        template: "\n\n    <mat-tab-group *ngIf=\"reportsGroups\" (selectedIndexChange)=\"onTabChanged($event)\">\n      <mat-tab  [id]=\"group.id\" *ngFor=\"let group of reportsGroups;let i=index\" label=\"{{group.name}}\" >\n        <mat-grid-list class=\"mt-2\" [cols]=\"breakpoint\"  rowHeight=\"200px\">\n          <mat-grid-tile *ngFor=\"let report of reportsByGroupId\">\n            <mat-card class=\"example-card\" >\n              <mat-card-title>{{report.name}}</mat-card-title>\n              <mat-card-content>\n                <p>{{report.descreption}}</p>\n              </mat-card-content>\n              <mat-card-actions>\n                <button mat-button class=\"viewButton\" (click)=\"viewReportFilterDetails(report)\">View</button>\n              </mat-card-actions>\n            </mat-card>\n          </mat-grid-tile>\n        </mat-grid-list>\n\n      </mat-tab>\n    </mat-tab-group>\n\n\n\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return [{ type: ReportsService }]; }, propDecorators: { onViewClicked: [{
                    type: i0.Output
                }] } });

    // import {MatInputModule} from "../../../../";
    // import {MatInputModule} from "@angular/material/input";
    var ReportsModule = /** @class */ (function () {
        function ReportsModule() {
        }
        return ReportsModule;
    }());
    ReportsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ReportsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsModule, declarations: [ReportsComponent], imports: [input.MatInputModule,
            formField.MatFormFieldModule,
            i2.MatTabsModule,
            i3.MatGridListModule,
            i4.MatCardModule,
            i5.MatButtonModule,
            i1.HttpClientModule,
            router.RouterModule], exports: [ReportsComponent] });
    ReportsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsModule, imports: [[
                input.MatInputModule,
                formField.MatFormFieldModule,
                i2.MatTabsModule,
                i3.MatGridListModule,
                i4.MatCardModule,
                i5.MatButtonModule,
                i1.HttpClientModule,
                router.RouterModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: ReportsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            ReportsComponent
                        ],
                        imports: [
                            input.MatInputModule,
                            formField.MatFormFieldModule,
                            i2.MatTabsModule,
                            i3.MatGridListModule,
                            i4.MatCardModule,
                            i5.MatButtonModule,
                            i1.HttpClientModule,
                            router.RouterModule
                        ],
                        exports: [
                            ReportsComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of reports
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ReportsComponent = ReportsComponent;
    exports.ReportsModule = ReportsModule;
    exports.ReportsService = ReportsService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=reports-hyper74.umd.js.map
